/*
	Auto-Ptr-3
*/

#if !defined( _AUTO_PTR_3__INITIALIZED_PTR_HPP_ )
#define _AUTO_PTR_3__INITIALIZED_PTR_HPP_

namespace auto_ptr_3 {

//
// initialized_ptr_t
//

//!	      .
/*!
	      
	/ - .  , 
	/ ,   .

	\par
	      
	 .    /
	    -.

	\par
	 \c initialized_ptr_t    
	    .

	\attention  \c initialized_ptr_t   ,
	      
	!
*/
template< class T >
class	initialized_ptr_t
{
	private :
		//!  .
		T *	m_p;

		typedef T * ptr_t;

	public :
		//!     0.
		initialized_ptr_t() : m_p( 0 ) {}
		//!     .
		initialized_ptr_t( T * p ) : m_p( p ) {}

		//!     .
		T *
		query()
		{
			return m_p;
		}

		//!     .
		const T *
		query() const
		{
			return m_p;
		}

		//!   .
		void
		set( T * p )
		{
			m_p = p;
		}

		//!     .
		operator ptr_t() const
		{
			return m_p;
		}

		//!       .
		/*! \attention   ,  
			  0.
		*/
		T &
		operator*()
		{
			return *m_p;
		}

		//!       .
		/*! \attention   ,  
			  0.
		*/
		const T &
		operator*() const
		{
			return *m_p;
		}

		//!     .
		T *
		operator->()
		{
			return m_p;
		}

		//!     .
		const T *
		operator->() const
		{
			return m_p;
		}
};

}

#endif

