/*

cls_2: Curl Like Syntax
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/
/*!
	\file
	\brief   ,    
		   .
	
*/

#if !defined( _CLS_2__ES_FILE_LINE_NUM_HPP_ )
#define _CLS_2__ES_FILE_LINE_NUM_HPP_

#include <auto_ptr_3/h/obj_ptr.hpp>
#include <auto_ptr_3/h/vect_ptr.hpp>

#include <cls_2/h/cls.hpp>
#include <cls_2/h/is_file.hpp>

namespace cls_2 {

//
// es_file_line_num_t
//

/*!
	\brief   ,    
	   .

	      
	 ,    
	  .

	       
	  out(),    
	str  \\n.
*/
class	es_file_line_num_t :
	public error_stream_t
{
	public :
		//!      .
		typedef auto_ptr_3::destroyable_obj_t< error_stream_t >
			destroyable_t;
		//!      .
		typedef auto_ptr_3::nondestroyable_obj_t< error_stream_t >
			nondestroyable_t;

		//!     
		//!  CLS.
		es_file_line_num_t(
			//!   .
			error_stream_t & real_err_stream,
			//!    .
			const input_stream_file_t & file );
		//!  .
		es_file_line_num_t(
			//!   .
			const auto_ptr_3::obj_destruction_t< error_stream_t > & to,
			//!  ,   
			//!       .
			const char * file_name,
			//!  .
			const input_stream_t & in );
		virtual ~es_file_line_num_t();

		//!      .
		virtual error_stream_t &
		out( const char * str );

	protected :
		//!   .
		auto_ptr_3::soft_obj_ptr_t< error_stream_t >
			m_real_err_stream;
		//!  ,    
		//!      .
		auto_ptr_3::vect_ptr_t< char >
			m_file_name;
		//!  .
		/*!
			  ,   
			  .
		*/
		const input_stream_t &	m_in;
		//!       ?
		bool	m_is_new_line;

		//!    .
		void
		set_file_name( const char * file_name );
};

} /* namespace cls_2 */

#endif
