/*

cls_2: Curl Like Syntax
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/
/*!
	\file
	\brief    
	    CLS.
*/

#if !defined( _CLS_2__TO_CLS_FORMAT_HPP_ )
#define _CLS_2__TO_CLS_FORMAT_HPP_

namespace cls_2 {

//
// to_cls_format_t
//

/*!
	\brief    
	    CLS.

	   NONSPACE:
\verbatim
'values {v1|v2|v3}' -> 'values \{v1\|v2\|v3\}'
\endverbatim

	   STRING:
\verbatim
'values {v1|v2|v3}' -> '"values \{v1\|v2\|v3\}"'
\endverbatim

*/
class	to_cls_format_t {
	public :
		//!   NONSPACE.
		/*!
			   
			 ,    
			.
		*/
		static char *
		format_nonspace( const char * v );

		//!   STRING.
		/*!
			   
			 ,    
			.
		*/
		static char *
		format_string( const char * v );
};

} /* namespace cls_2 */

#endif
