/*

cls_2: Curl Like Syntax
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/
#include <cls_2/std_cpp/h/es_ostringstream.hpp>

namespace cls_2 {

namespace std_cpp {

//
// es_ostringstream_t
//
es_ostringstream_t::es_ostringstream_t() {
	set_stream( &m_stream );
}

es_ostringstream_t::~es_ostringstream_t() {
}

void
es_ostringstream_t::get( std::string & recv ) {
	recv = m_stream.str();
}

} /* namespace std_cpp */

} /* namespace cls_2 */
