{type
key_type_t
	{extensible}

	{attr m_index {of oess_1::uint_t}}
}

{type
value_t
	{extensible}
	{subclassing_by_extension}

	{attr	m_value {of std::string}}

	{extension
		{attr m_version {of std::string}
			{default {c++ \"1.0\"}}}
	}
}

{type
data_t

	{attr m_data {of {extension_of} value_t}
		{stl-map {key key_type_t}}}
}

{type
timeout_value_t
	{extensible}
	{subclassing_by_extension {extension_of value_t}}

	{attr	m_millisec {of oess_1::uint_t}}

	{extension
		{attr	m_period {of oess_1::uint_t}
			{default {c++ 0 }}}
	}
}

{type
compression_value_t
	{extensible}
	{subclassing_by_extension {extension_of value_t}}

	{attr	m_preferred {of std::string}}

	{extension
		{attr	m_level {of oess_1::short_t}
			{default {c++ 9}}}
	}
}

{type
rar_compression_value_t
	{extensible}
	{subclassing_by_extension {extension_of compression_value_t}}

	{attr	m_dict_size {of oess_1::uint_t}}
}

{type
signature_value_t
	{extensible}
	{subclassing_by_extension {extension_of value_t}}

	{attr	m_algorithm {of std::string}}
}

{type
cipher_value_t
	{extensible}
	{subclassing_by_extension {extension_of value_t}}

	{attr	m_preferred {of std::string}}
}

{type
symmetric_cipher_value_t
	{abstract}
	{extensible}
	{subclassing_by_extension {extension_of cipher_value_t}}

	{attr	m_key_length {of oess_1::uint_t}}
}

{type
blowfish_cipher_value_t
	{extensible}
	{subclassing_by_extension {extension_of symmetric_cipher_value_t}}
}

{type
idea_cipher_value_t
	{extensible}
	{subclassing_by_extension {extension_of symmetric_cipher_value_t}}

	{attr	m_license_no {of std::string}}
}

{type
asymmetric_cipher_value_t
	{abstract}
	{extensible}
	{subclassing_by_extension {extension_of cipher_value_t}}
}
