/*

cls_2: Curl Like Syntax
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/
#if !defined( _CLS_2__DEF_MSG_STORAGE_HPP_ )
#define _CLS_2__DEF_MSG_STORAGE_HPP_

#include <cls_2/h/cls.hpp>

namespace cls_2 {

//
// def_msg_storage_t
//

class	def_msg_storage_t :
	public msg_storage_t {
	public :
		def_msg_storage_t();
		virtual ~def_msg_storage_t();

		// Searches message by message id.
		// Returns 0 if message not found.
		virtual const char *
		find( int msg_id ) const;
};

} /* namespace cls_1 */

#endif
