/*

cls_2: Curl Like Syntax
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/
#if !defined( _CLS_2__STD_CPP__ES_IOS_HPP_ )
#define _CLS_2__STD_CPP__ES_IOS_HPP_

#include <iostream>

#include <cls_2/h/cls.hpp>

namespace cls_2 {

namespace std_cpp {

/*
** es_ios_t
*/
class	es_ios_t :
	public error_stream_t {
	public :
		// Default constructor for std::CERR
		es_ios_t();
		es_ios_t(
			std::ostream * stream );
		virtual ~es_ios_t();

		std::ostream *
		set_stream(
			std::ostream * stream );

		virtual error_stream_t &
		out( const char * str );

	private :
		std::ostream *	m_stream;
};

} /* namespace namespace std_cpp */

} /* namespace cls_2 */

#endif
