/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\file oess_1/defs/h/types.hpp
	\brief    .
*/

#if !defined( _OESS_1__DEFS__TYPES_HPP_ )
#define _OESS_1__DEFS__TYPES_HPP_

#include <ace/Basic_Types.h>

namespace oess_1 {

//! 8- .
/*!
	   ,   
	 . ObjESSty    
	.
*/
typedef	char	char_t;

//! 8-  .
typedef signed char	schar_t;
//! 8-  .
typedef unsigned char	uchar_t;

//! 16-  .
typedef ACE_INT16	short_t;
//! 16-  .
typedef ACE_UINT16	ushort_t;

//! 32-  .
typedef ACE_INT32	int_t;
//! 32-  .
typedef ACE_UINT32 uint_t;

//! 32-   .
typedef float	single_t;
//! 64-   .
typedef double	double_t;

} /* namespace oess_1 */

#endif

