require	'mxx_ru/cpp'

require 'oess_1/util_cpp_serializer/gen'

Mxx_ru::setup_target(
	Mxx_ru::Cpp::Exe_target.new( "sample/subextension.auto_ptr/prj.rb" ) {

		required_prj( "ace/dll.rb" )

		required_prj( "oess_1/defs/prj.rb" )
		required_prj( "oess_1/io/prj.rb" )
		required_prj( "oess_1/stdsn/prj.rb" )

		generator( Oess_1::Util_cpp_serializer::Gen.new( self ) ).
			ddl_file( "main.ddl" )

		target( "sample_subextension.auto_ptr" )

		cpp_source( "main.cpp" )
	}
)
