/*

smart_ref_3: Smart Reference library
Yauheni A. Akhotnikau (C) 2001-2003
eao197@yahoo.com
-------------------------------------------------

Permission is granted to anyone to use this software for any purpose on any
computer system, and to redistribute it freely, subject to the following
restrictions:

1. This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

2. The origin of this software must not be misrepresented, either by
   explicit claim or by omission.

3. Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.

-------------------------------------------------

*/

/*!
	\file
	\brief	 /.
*/

#if !defined( _SMART_REF_3__DECLSPEC_HPP_ )
#define _SMART_REF_3__DECLSPEC_HPP_

#if defined( SMART_REF_3_DLL )
	// Dynamic link library smart_ref.3.0 (.dll, .so)

	#include <cpp_util_2/h/detect_compiler.hpp>

	#if defined( SMART_REF_3_PRJ )
		#define SMART_REF_3_TYPE\
		CPP_UTIL_2_EXPORT

		#define SMART_REF_3_FUNC(ret_type)\
		CPP_UTIL_2_EXPORT_FUNC_SPEC(ret_type)

	#else
		#define SMART_REF_3_TYPE\
		CPP_UTIL_2_IMPORT

		#define SMART_REF_3_FUNC_SPEC(ret_type)\
		CPP_UTIL_2_IMPORT_FUNC_SPEC(ret_type)
	#endif

#else
	// Static library smart_ref.3.0 (.lib, .a)
	#define SMART_REF_3_TYPE

	#define SMART_REF_3_FUNC(ret_type)\
	ret_type
#endif

#endif
